## rdma-core 56.1

=== CMakeLists.txt ===
# COPYRIGHT (c) 2016 Obsidian Research Corporation. See COPYING file
# Run cmake as:
#  mkdir build
#  cmake -GNinja ..
#  ninja
#
# Common options passed to cmake are:
#  -DIN_PLACE=1
#      Configure the build to be run from the build directory, this results in something
#      that is not installable.
#  -DCMAKE_EXPORT_COMPILE_COMMANDS=1
#      Write a compile_commands.json file for clang tooling
#  -DCMAKE_BUILD_TYPE=RelWithDebInfo
#      Change the optimization level, Debug disables optimization,
#      Release is for packagers
#  -DENABLE_VALGRIND=0 (default enabled)
#      Disable valgrind notations, this has a tiny positive performance impact
#  -DENABLE_RESOLVE_NEIGH=0 (default enabled)
#      Do not link to libnl and do not resolve neighbours internally for Ethernet,
#      and do not build iwpmd.
#  -DENABLE_STATIC=1 (default disabled)
#      Produce static libraries along with the usual shared libraries.
#  -DVERBS_PROVIDER_DIR='' (default /usr/lib.../libibverbs)
#      Use the historical search path for providers, in the standard system library.
#  -DNO_COMPAT_SYMS=1 (default disabled)
#      Do not generate backwards compatibility symbols in the shared
#      libraries. This may is necessary if using a dynmic linker that does
#      not support symbol versions, such as uclibc.
#  -DIOCTL_MODE=write (default both)
#      Disable new kABI ioctl() support and support only the legacy write
#      path. May also be 'ioctl' to disable fallback to write.
#  -DIBACM_SERVER_MODE_DEFAULT (default unix)
#      Selects how clients can connect to this server:
#      open) Allow incoming connections from any TCP client (internal or external).
#      loop) Limit incoming connections for server_port to 127.0.0.1.
#      unix) Use unix-domain sockets, hence limits service to the same machine.
#  -DIBACM_ACME_PLUS_KERNEL_ONLY_DEFAULT (default 0)
#      If non-zero, limit incoming requests to kernel or the ib_acme utility
#      (i.e. do not serve librdmacm requests)
#  -DPYTHON_EXECUTABLE
#      Override automatic detection of python to use a certain
#      exectuable. This can be used to force the build to use python2 on a
#      system that has python3 installed. Otherwise the build automatically
#      prefers python3 if available.
#   -DNO_PYVERBS=1 (default, build pyverbs)
#      Invoke cython to build pyverbs. Usually you will run with this option
#      set
#   -DENABLE_IBDIAGS_COMPAT=True (default False)
#      Include obsolete scripts. These scripts are replaced by C programs with
#      a different interface now.
#   -DNO_MAN_PAGES=1 (default 0, build/install the man pages)
#      Disable man pages. Allows rdma-core to be built and installed
#      (without man pages) when neither pandoc/rst2man nor the pandoc-prebuilt
#      directory are available.
#   -DENABLE_LTTNG (default, no tracing support)
#      Enable LTTng tracing.

if (${CMAKE_VERSION} VERSION_LESS "3.18.1")
	# Centos 7 support
	cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
else()
	cmake_minimum_required(VERSION 3.18.1 FATAL_ERROR)
endif()
project(rdma-core C)

# CMake likes to use -rdynamic too much, they fixed it in 3.4.
if(POLICY CMP0065)
  cmake_policy(SET CMP0065 NEW)
else()
  # .. but we really do want to opt out.
  string(REPLACE "-rdynamic" "" CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "${CMAKE_SHARED_LIBRARY_LINK_C_FLAGS}")
endif()

# Make RDMA_CHECK_C_LINKER_FLAG work better
if(POLICY CMP0056)
  cmake_policy(SET CMP0056 NEW)
endif()

set(PACKAGE_NAME "RDMA")

# See Documentation/versioning.md
set(PACKAGE_VERSION "56.1")
# When this is changed the values in these files need changing too:
#   debian/control
#   debian/libibverbs1.symbols
set(IBVERBS_PABI_VERSION "34")
set(IBVERBS_PROVIDER_SUFFIX "-rdmav${IBVERBS_PABI_VERSION}.so")

#-------------------------
# Basic standard paths

# Override the CMAKE_INSTALL_ dirs to be under the build/ directory
if (IN_PLACE)
  set(CMAKE_INSTALL_SYSCONFDIR "${PROJECT_BINARY_DIR}/etc")
  set(CMAKE_INSTALL_BINDIR "${PROJECT_BINARY_DIR}/bin")
  set(CMAKE_INSTALL_SBINDIR "${PROJECT_BINARY_DIR}/bin")
  set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}")
  set(CMAKE_INSTALL_LIBDIR "lib")
  set(CMAKE_INSTALL_INCLUDEDIR "include")
endif()

include(GNUInstallDirs)
# C include root
set(BUILD_INCLUDE ${PROJECT_BINARY_DIR}/include)
# Executables
set(BUILD_BIN ${PROJECT_BINARY_DIR}/bin)
# Libraries
set(BUILD_LIB ${PROJECT_BINARY_DIR}/lib)
# Static library pre-processing
set(BUILD_STATIC_LIB ${PROJECT_BINARY_DIR}/lib/statics)
# Used for IN_PLACE configuration
set(BUILD_ETC ${PROJECT_BINARY_DIR}/etc)
set(BUILD_PYTHON ${PROJECT_BINARY_DIR}/python)

set(IBDIAG_CONFIG_PATH "${CMAKE_INSTALL_FULL_SYSCONFDIR}/infiniband-diags")
set(IBDIAG_NODENAME_MAP_PATH "${CMAKE_INSTALL_FULL_SYSCONFDIR}/rdma/ib-node-name-map")

set(CMAKE_INSTALL_INITDDIR "${CMAKE_INSTALL_SYSCONFDIR}/init.d"
  CACHE PATH "Location for init.d files")
set(CMAKE_INSTALL_MODPROBEDIR "${CMAKE_INSTALL_SYSCONFDIR}/modprobe.d/"
  CACHE PATH "Location for modprobe.d files")
set(CMAKE_INSTALL_SYSTEMD_SERVICEDIR "${CMAKE_INSTALL_PREFIX}/lib/systemd/system"
  CACHE PATH "Location for systemd service files")
set(CMAKE_INSTALL_SYSTEMD_BINDIR "/lib/systemd"
  CACHE PATH "Location for systemd extra binaries")

set(ACM_PROVIDER_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/ibacm"
  CACHE PATH "Location for ibacm provider plugin shared library files.")
# Location to find the provider plugin shared library files
set(VERBS_PROVIDER_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/libibverbs"
  CACHE PATH "Location for provider plugin shared library files. If set to empty the system search path is used.")

# Allow the 'run' dir to be configurable, this historically has been /var/run, but
# some systems now use /run/
set(CMAKE_INSTALL_RUNDIR "var/run"
  CACHE PATH "Location for runtime information, typically /var/run, or /run")
if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_RUNDIR})
  set(CMAKE_INSTALL_FULL_RUNDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_RUNDIR}")
else()
  set(CMAKE_INSTALL_FULL_RUNDIR "${CMAKE_INSTALL_RUNDIR}")
endif()

# Allow the udev rules.d dir to be configurable, this has historically been
# /lib/udev/rules.d/, but some systems now prefix /usr/
set(CMAKE_INSTALL_UDEV_RULESDIR "lib/udev/rules.d"
  CACHE PATH "Location for system udev rules, typically /lib/udev/rules.d or /usr/lib/udev/rules.d")
if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_UDEV_RULESDIR})
  set(CMAKE_INSTALL_FULL_UDEV_RULESDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_UDEV_RULESDIR}")
else()
  set(CMAKE_INSTALL_FULL_UDEV_RULESDIR "${CMAKE_INSTALL_UDEV_RULESDIR}")
endif()

# Allow the perl library dir to be configurable
set(CMAKE_INSTALL_PERLDIR "share/perl5"
  CACHE PATH "Location for system perl library, typically /usr/share/perl5")
if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_PERLDIR})
  set(CMAKE_INSTALL_FULL_PERLDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_PERLDIR}")
else()
  set(CMAKE_INSTALL_FULL_PERLDIR "${CMAKE_INSTALL_PERLDIR}")
endif()

# Location to place provider .driver files
if (IN_PLACE)
  set(CONFIG_DIR "${BUILD_ETC}/libibverbs.d")
  set(VERBS_PROVIDER_DIR "${BUILD_LIB}")
  set(ACM_PROVIDER_DIR "${BUILD_LIB}/ibacm")
else()
  set(CONFIG_DIR "${CMAKE_INSTALL_FULL_SYSCONFDIR}/libibverbs.d")
endif()

set(DISTRO_FLAVOUR "None" CACHE
  STRING "Flavour of distribution to install for. This primarily impacts the init.d scripts installed.")

#-------------------------
# Load CMake components
set(BUILDLIB "${PROJECT_SOURCE_DIR}/buildlib")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${BUILDLIB}")

include(CMakeParseArguments)
include(CheckCCompilerFlag)
include(CheckCSourceCompiles)
include(CheckIncludeFile)
include(CheckTypeSize)
include(RDMA_EnableCStd)
include(RDMA_Sparse)
include(RDMA_BuildType)
include(RDMA_DoFixup)
include(publish_headers)
include(rdma_functions)
include(pyverbs_functions)

check_c_compiler_flag("-Wcast-align=strict" HAVE_WCAST_ALIGN_STRICT)

if (NO_MAN_PAGES)
  # define empty stub functions to omit man page processing
  function(rdma_man_pages)
  endfunction()
  function(rdma_alias_man_pages)
  endfunction()
else()
  include(rdma_man)
endif()

if (NOT DEFINED ENABLE_STATIC)
  set(ENABLE_STATIC "OFF" CACHE BOOL "Produce static linking libraries as well as shared libraries.")
endif()

#-------------------------
# Setup the basic C compiler
RDMA_BuildType()
include_directories(${BUILD_INCLUDE})

# Working means that the compiler doesn't spew output that confuses cmake's
# capabilitiy tests. ie cmake will test and succeed a simple program
RDMA_Check_C_Compiles(HAVE_WORKING_WERROR "int main(int argc,const char *argv[]) { return 0; }" "")
if (NOT HAVE_WORKING_WERROR)
  message(FATAL_ERROR "-Werror doesn't work (compiler always creates warnings?). Werror is required for CMake.")
endif()

# Use Python modules based on CMake version for backward compatibility
if (${CMAKE_VERSION} VERSION_LESS "3.12")
        FIND_PACKAGE(PythonInterp REQUIRED)
        FIND_PACKAGE(PythonLibs ${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR} EXACT)
elseif (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12")
        set(Python_EXECUTABLE ${PYTHON_EXECUTABLE})
        FIND_PACKAGE(Python 3 REQUIRED COMPONENTS Interpreter OPTIONAL_COMPONENTS Development)
        set(PYTHON_EXECUTABLE ${Python_EXECUTABLE})
        if(Python_Development_FOUND)
            set(PYTHONLIBS_FOUND ${Python_Development_FOUND})
            set(PYTHON_LIBRARIES ${Python_LIBRARIES})
            set(PYTHON_INCLUDE_DIRS ${Python_INCLUDE_DIRS})
        endif()
endif()

set(CYTHON_EXECUTABLE "")
if(NOT NO_PYVERBS AND PYTHONLIBS_FOUND)
    execute_process(COMMAND "${PYTHON_EXECUTABLE}" -c
        "import sysconfig; print(sysconfig.get_path(\"platlib\"))"
        OUTPUT_VARIABLE py_path)
    string(STRIP ${py_path} py_path)
    set(CMAKE_INSTALL_PYTHON_ARCH_LIB "${py_path}"
        CACHE PATH "Location for architecture specific python libraries")

    # See PEP3149
    execute_process(COMMAND "${PYTHON_EXECUTABLE}" -c
        "import sysconfig; x = sysconfig.get_config_var(\"EXT_SUFFIX\"); print(x if x else '.so')"
        OUTPUT_VARIABLE py_path)
    string(STRIP ${py_path} CMAKE_PYTHON_SO_SUFFIX)

    FIND_PACKAGE(cython)
elseif(NOT NO_PYVERBS AND NOT PYTHONLIBS_FOUND)
    message(WARNING "pyverbs build requested but python development files not found")
endif()

find_program(SYSTEMCTL_BIN systemctl HINTS "/usr/bin" "/bin")
if (NOT SYSTEMCTL_BIN)
  set (SYSTEMCTL_BIN "/bin/systemctl")
endif()

RDMA_CheckSparse()

# Require GNU99 mode
RDMA_EnableCStd()

# Extra warnings. Turn on -Wextra to keep aware of interesting developments from gcc,
# but turn off some that are not terribly useful for this source.
# FIXME: I wonder how many of the signed compares are bugs?
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WARNINGS
  "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WMISSING_PROTOTYPES "-Wmissing-prototypes")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WMISSING_DECLARATIONS "-Wmissing-declarations")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WWRITE_STRINGS "-Wwrite-strings")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WFORMAT_2 "-Wformat=2")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WCAST_FUNCTION "-Wcast-function-type")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WFORMAT_NONLITERAL "-Wformat-nonliteral")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WDATE_TIME "-Wdate-time")
RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WNESTED_EXTERNS "-Wnested-externs")

# At some point after 4.4 gcc fixed shadow to ignore function vs variable
# conflicts
RDMA_Check_C_Compiles(HAVE_C_WORKING_SHADOW "
 #include <unistd.h>
 int main(int argc,const char *argv[]) { int access = 1; return access; }"
  "-Wshadow")
if (HAVE_C_WORKING_SHADOW)
  RDMA_AddOptCFlag(CMAKE_C_FLAGS HAVE_C_WORKING_SHADOW "-Wshadow")
endif()

# At some point around 5.4 gcc fixed missing-field-initializers to ignore this
# common idiom we use extensively. Since this is a useful warning for
# developers try and leave it on if the compiler supports it.

=== pyverbs/CMakeLists.txt ===
# SPDX-License-Identifier: (GPL-2.0 OR Linux-OpenIB)
# Copyright (c) 2019, Mellanox Technologies. All rights reserved. See COPYING file
# Copyright (c) 2020, Intel Corporation. All rights reserved. See COPYING file

publish_internal_headers(""
  dmabuf_alloc.h
)

if (DRM_INCLUDE_DIRS)
  set(DMABUF_ALLOC dmabuf_alloc.c)
else()
  set(DMABUF_ALLOC dmabuf_alloc_stub.c)
endif()

if (HAVE_COHERENT_DMA)
  set(DMA_UTIL dma_util.pyx)
else()
  set(DMA_UTIL "")
endif()

rdma_cython_module(pyverbs ""
  addr.pyx
  base.pyx
  cm_enums.pyx
  cmid.pyx
  cq.pyx
  device.pyx
  ${DMA_UTIL}
  dmabuf.pyx
  ${DMABUF_ALLOC}
  enums.pyx
  flow.pyx
  fork.pyx
  libibverbs.pyx
  libibverbs_enums.pyx
  librdmacm.pyx
  librdmacm_enums.pyx
  mem_alloc.pyx
  mr.pyx
  pd.pyx
  qp.pyx
  spec.pyx
  srq.pyx
  wq.pyx
  wr.pyx
  xrcd.pyx
)

rdma_python_module(pyverbs
  __init__.py
  pyverbs_error.py
  utils.py
  )

# mlx5 and efa providers are not built without coherent DMA, e.g. ARM32 build.
if (HAVE_COHERENT_DMA)
add_subdirectory(providers/mlx5)
add_subdirectory(providers/efa)
endif()

=== srp_daemon/CMakeLists.txt ===
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${NO_STRICT_ALIASING_FLAGS}")

rdma_man_pages(
  ibsrpdm.8
  srp_daemon.8.in
  srp_daemon.service.5
  srp_daemon_port@.service.5
  )

rdma_sbin_executable(srp_daemon
  srp_daemon.c
  srp_handle_traps.c
  srp_sync.c
  )
target_link_libraries(srp_daemon LINK_PRIVATE
  ibverbs
  ibumad
  ${RT_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  )

rdma_install_symlink(srp_daemon "${CMAKE_INSTALL_SBINDIR}/ibsrpdm")
# FIXME: Why?
rdma_install_symlink(srp_daemon "${CMAKE_INSTALL_SBINDIR}/run_srp_daemon")
rdma_subst_install(FILES "srp_daemon.sh.in"
  DESTINATION "${CMAKE_INSTALL_SBINDIR}"
  RENAME "srp_daemon.sh"
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

rdma_subst_install(FILES start_on_all_ports.in
  DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/srp_daemon"
  RENAME start_on_all_ports
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

rdma_subst_install(FILES srp_daemon.service.in
  DESTINATION "${CMAKE_INSTALL_SYSTEMD_SERVICEDIR}"
  RENAME srp_daemon.service
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

rdma_subst_install(FILES srp_daemon_port@.service.in
  DESTINATION "${CMAKE_INSTALL_SYSTEMD_SERVICEDIR}"
  RENAME srp_daemon_port@.service
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

install(FILES srp_daemon.conf DESTINATION "${CMAKE_INSTALL_SYSCONFDIR}")

rdma_subst_install(FILES "srp_daemon.rules.in"
  RENAME "60-srp_daemon.rules"
  DESTINATION "${CMAKE_INSTALL_UDEV_RULESDIR}")

install(FILES modules-srp_daemon.conf
  RENAME "srp_daemon.conf"
  DESTINATION "${CMAKE_INSTALL_SYSCONFDIR}/rdma/modules")

# FIXME: The ib init.d file should really be included in rdma-core as well.
set(RDMA_SERVICE "openibd" CACHE STRING "init.d file service name to order srpd after")
# NOTE: These defaults are for CentOS, packagers should override.
set(SRP_DEFAULT_START "2 3 4 5" CACHE STRING "Default-Start service data for srpd")
set(SRP_DEFAULT_STOP "0 1 6" CACHE STRING "Default-Stop service data for srpd")
configure_file(srpd.in "${CMAKE_CURRENT_BINARY_DIR}/srpd")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/srpd"
  DESTINATION "${CMAKE_INSTALL_INITDDIR}"
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

=== libibverbs/man/CMakeLists.txt ===
rdma_man_pages(
  ibv_advise_mr.3.md
  ibv_alloc_dm.3
  ibv_alloc_mw.3
  ibv_alloc_null_mr.3.md
  ibv_alloc_parent_domain.3
  ibv_alloc_pd.3
  ibv_alloc_td.3
  ibv_asyncwatch.1
  ibv_attach_counters_point_flow.3.md
  ibv_attach_mcast.3.md
  ibv_bind_mw.3
  ibv_create_ah.3
  ibv_create_ah_from_wc.3
  ibv_create_comp_channel.3
  ibv_create_counters.3.md
  ibv_create_cq.3
  ibv_create_cq_ex.3
  ibv_modify_cq.3
  ibv_create_flow.3
  ibv_create_flow_action.3.md
  ibv_create_qp.3
  ibv_create_qp_ex.3
  ibv_create_rwq_ind_table.3
  ibv_create_srq.3
  ibv_create_srq_ex.3
  ibv_create_wq.3
  ibv_devices.1
  ibv_devinfo.1
  ibv_event_type_str.3.md
  ibv_fork_init.3.md
  ibv_get_async_event.3
  ibv_get_cq_event.3
  ibv_get_device_guid.3.md
  ibv_get_device_index.3.md
  ibv_get_device_list.3.md
  ibv_get_device_name.3.md
  ibv_get_pkey_index.3.md
  ibv_get_srq_num.3.md
  ibv_import_device.3.md
  ibv_import_dm.3.md
  ibv_import_mr.3.md
  ibv_import_pd.3.md
  ibv_inc_rkey.3.md
  ibv_is_fork_initialized.3.md
  ibv_modify_qp.3
  ibv_modify_qp_rate_limit.3
  ibv_modify_srq.3
  ibv_modify_wq.3
  ibv_open_device.3
  ibv_open_qp.3
  ibv_open_xrcd.3
  ibv_poll_cq.3
  ibv_post_recv.3
  ibv_post_send.3
  ibv_post_srq_ops.3
  ibv_post_srq_recv.3
  ibv_query_device.3
  ibv_query_device_ex.3
  ibv_query_ece.3.md
  ibv_query_gid.3.md
  ibv_query_gid_ex.3.md
  ibv_query_gid_table.3.md
  ibv_query_pkey.3.md
  ibv_query_port.3
  ibv_query_qp.3
  ibv_query_qp_data_in_order.3.md
  ibv_query_rt_values_ex.3
  ibv_query_srq.3
  ibv_rate_to_mbps.3.md
  ibv_rate_to_mult.3.md
  ibv_rc_pingpong.1
  ibv_read_counters.3.md
  ibv_reg_mr.3
  ibv_req_notify_cq.3.md
  ibv_rereg_mr.3.md
  ibv_resize_cq.3.md
  ibv_set_ece.3.md
  ibv_srq_pingpong.1
  ibv_uc_pingpong.1
  ibv_ud_pingpong.1
  ibv_wr_post.3.md
  ibv_xsrq_pingpong.1
  )
rdma_alias_man_pages(
  ibv_alloc_dm.3 ibv_free_dm.3
  ibv_alloc_dm.3 ibv_reg_dm_mr.3
  ibv_alloc_dm.3 ibv_memcpy_to_dm.3
  ibv_alloc_dm.3 ibv_memcpy_from_dm.3
  ibv_alloc_mw.3 ibv_dealloc_mw.3
  ibv_alloc_pd.3 ibv_dealloc_pd.3
  ibv_alloc_td.3 ibv_dealloc_td.3
  ibv_attach_mcast.3 ibv_detach_mcast.3
  ibv_create_ah.3 ibv_destroy_ah.3
  ibv_create_ah_from_wc.3 ibv_init_ah_from_wc.3
  ibv_create_comp_channel.3 ibv_destroy_comp_channel.3
  ibv_create_counters.3 ibv_destroy_counters.3
  ibv_create_cq.3 ibv_destroy_cq.3
  ibv_create_flow.3 ibv_destroy_flow.3
  ibv_create_flow_action.3 ibv_destroy_flow_action.3
  ibv_create_flow_action.3 ibv_modify_flow_action.3
  ibv_create_qp.3 ibv_destroy_qp.3
  ibv_create_rwq_ind_table.3 ibv_destroy_rwq_ind_table.3
  ibv_create_srq.3 ibv_destroy_srq.3
  ibv_create_wq.3 ibv_destroy_wq.3
  ibv_event_type_str.3 ibv_node_type_str.3
  ibv_event_type_str.3 ibv_port_state_str.3
  ibv_get_async_event.3 ibv_ack_async_event.3
  ibv_get_cq_event.3 ibv_ack_cq_events.3
  ibv_get_device_list.3 ibv_free_device_list.3
  ibv_import_pd.3 ibv_unimport_pd.3
  ibv_import_dm.3 ibv_unimport_dm.3
  ibv_import_mr.3 ibv_unimport_mr.3
  ibv_open_device.3 ibv_close_device.3
  ibv_open_xrcd.3 ibv_close_xrcd.3
  ibv_rate_to_mbps.3 mbps_to_ibv_rate.3
  ibv_rate_to_mult.3 mult_to_ibv_rate.3
  ibv_reg_mr.3 ibv_dereg_mr.3
  ibv_wr_post.3 ibv_wr_abort.3
  ibv_wr_post.3 ibv_wr_complete.3
  ibv_wr_post.3 ibv_wr_start.3
  ibv_wr_post.3 ibv_wr_atomic_cmp_swp.3
  ibv_wr_post.3 ibv_wr_atomic_fetch_add.3
  ibv_wr_post.3 ibv_wr_bind_mw.3
  ibv_wr_post.3 ibv_wr_local_inv.3
  ibv_wr_post.3 ibv_wr_rdma_read.3
  ibv_wr_post.3 ibv_wr_rdma_write.3
  ibv_wr_post.3 ibv_wr_rdma_write_imm.3
  ibv_wr_post.3 ibv_wr_send.3
  ibv_wr_post.3 ibv_wr_send_imm.3
  ibv_wr_post.3 ibv_wr_send_inv.3
  ibv_wr_post.3 ibv_wr_send_tso.3
  ibv_wr_post.3 ibv_wr_set_inline_data.3
  ibv_wr_post.3 ibv_wr_set_inline_data_list.3
  ibv_wr_post.3 ibv_wr_set_sge.3
  ibv_wr_post.3 ibv_wr_set_sge_list.3
  ibv_wr_post.3 ibv_wr_set_ud_addr.3
  ibv_wr_post.3 ibv_wr_set_xrc_srqn.3
  ibv_wr_post.3 ibv_wr_flush.3
  )

=== librdmacm/examples/CMakeLists.txt ===
# Shared example files
add_library(rdmacm_tools STATIC
  common.c
  )
target_link_libraries(rdmacm_tools LINK_PRIVATE ${CMAKE_THREAD_LIBS_INIT})

rdma_executable(cmtime cmtime.c)
target_link_libraries(cmtime LINK_PRIVATE rdmacm rdmacm_tools)

rdma_executable(mckey mckey.c)
target_link_libraries(mckey LINK_PRIVATE rdmacm ${CMAKE_THREAD_LIBS_INIT} rdmacm_tools)

rdma_executable(rcopy rcopy.c)
target_link_libraries(rcopy LINK_PRIVATE rdmacm rdmacm_tools)

rdma_executable(rdma_client rdma_client.c)
target_link_libraries(rdma_client LINK_PRIVATE rdmacm)

rdma_executable(rdma_server rdma_server.c)
target_link_libraries(rdma_server LINK_PRIVATE rdmacm)

rdma_executable(rdma_xclient rdma_xclient.c)
target_link_libraries(rdma_xclient LINK_PRIVATE rdmacm)

rdma_executable(rdma_xserver rdma_xserver.c)
target_link_libraries(rdma_xserver LINK_PRIVATE rdmacm)

rdma_executable(riostream riostream.c)
target_link_libraries(riostream LINK_PRIVATE rdmacm rdmacm_tools)

rdma_executable(rping rping.c)
target_link_libraries(rping LINK_PRIVATE rdmacm ${CMAKE_THREAD_LIBS_INIT} rdmacm_tools)

rdma_executable(rstream rstream.c)
target_link_libraries(rstream LINK_PRIVATE rdmacm rdmacm_tools)

rdma_executable(ucmatose cmatose.c)
target_link_libraries(ucmatose LINK_PRIVATE rdmacm rdmacm_tools)

rdma_executable(udaddy udaddy.c)
target_link_libraries(udaddy LINK_PRIVATE rdmacm rdmacm_tools)

rdma_executable(udpong udpong.c)
target_link_libraries(udpong LINK_PRIVATE rdmacm rdmacm_tools)

=== providers/mlx4/CMakeLists.txt ===
rdma_shared_provider(mlx4 libmlx4.map
  1 1.0.${PACKAGE_VERSION}
  buf.c
  cq.c
  dbrec.c
  mlx4.c
  qp.c
  srq.c
  verbs.c
)

publish_headers(infiniband
  mlx4dv.h
)

install(FILES "mlx4.conf" DESTINATION "${CMAKE_INSTALL_MODPROBEDIR}/")

rdma_pkg_config("mlx4" "libibverbs" "${CMAKE_THREAD_LIBS_INIT}")

=== providers/rxe/CMakeLists.txt ===
if (ENABLE_LTTNG AND LTTNGUST_FOUND)
  set(TRACE_FILE rxe_trace.c)
endif()

rdma_provider(rxe
  ${TRACE_FILE}
  rxe.c
  )

if (ENABLE_LTTNG AND LTTNGUST_FOUND)
	target_include_directories("rxe-rdmav${IBVERBS_PABI_VERSION}" PUBLIC ".")
	target_link_libraries("rxe-rdmav${IBVERBS_PABI_VERSION}" LINK_PRIVATE LTTng::UST)
endif()

=== providers/vmw_pvrdma/CMakeLists.txt ===
rdma_provider(vmw_pvrdma
  cq.c
  pvrdma_main.c
  qp.c
  verbs.c
)

=== util/tests/CMakeLists.txt ===
rdma_test_executable(bitmap_test bitmap_test.c)
target_link_libraries(bitmap_test LINK_PRIVATE rdma_util)

=== providers/hns/man/CMakeLists.txt ===
rdma_man_pages(
  hnsdv.7.md
  hnsdv_create_qp.3.md
  hnsdv_is_supported.3.md
  hnsdv_query_device.3.md
)

=== pyverbs/providers/mlx5/CMakeLists.txt ===
# SPDX-License-Identifier: (GPL-2.0 OR Linux-OpenIB)
# Copyright (c) 2019, Mellanox Technologies. All rights reserved. See COPYING file

rdma_cython_module(pyverbs/providers/mlx5 mlx5
  dr_action.pyx
  dr_domain.pyx
  dr_matcher.pyx
  dr_rule.pyx
  dr_table.pyx
  libmlx5.pyx
  mlx5_enums.pyx
  mlx5_vfio.pyx
  mlx5dv.pyx
  mlx5dv_crypto.pyx
  mlx5dv_dmabuf.pyx
  mlx5dv_flow.pyx
  mlx5dv_mkey.pyx
  mlx5dv_objects.pyx
  mlx5dv_sched.pyx
)

=== debian/changelog ===
rdma-core (56.1-1) unstable; urgency=medium

  * New upstream bug-fix release
  * Drop patches applied upstream

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 14 Apr 2025 12:41:06 +0200

=== debian/control ===
Source: rdma-core
Maintainer: Benjamin Drung <bdrung@ubuntu.com>
Section: net
Priority: optional
Build-Depends: cmake (>= 2.8.11),
               cython3,
               debhelper-compat (= 13),
               dh-python,
               dpkg-dev (>= 1.22.5),
               libnl-3-dev,
               libnl-route-3-dev,
               libsystemd-dev,
               libudev-dev,
               ninja-build,
               pandoc,
               pkgconf,
               python3-dev,
               python3-docutils,
               valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x]
Rules-Requires-Root: no
Standards-Version: 4.7.2
Vcs-Git: https://github.com/linux-rdma/rdma-core.git -b debian/unstable
Vcs-Browser: https://github.com/linux-rdma/rdma-core
Homepage: https://github.com/linux-rdma/rdma-core

Package: rdma-core
Architecture: linux-any
Depends: udev, ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: dmidecode, ethtool, iproute2
Breaks: infiniband-diags (<< 2.0.0)
Replaces: infiniband-diags (<< 2.0.0)
Description: RDMA core userspace infrastructure and documentation
 This package provides the basic boot time support for systems that use the
 Linux kernel's remote direct memory access (RDMA) subystem which includes
 InfiniBand, iWARP, and RDMA over Converged Ethernet (RoCE).
 .
 Several kernel RDMA support daemons are included:
  - The rdma-ndd daemon which watches for RDMA device changes and/or hostname
    changes and updates the Node Description of the RDMA devices based on
    those changes.
  - The iWARP Port Mapper Daemon (iwpmd) which provides a kernel support
    service in userspace for iWARP drivers to claim TCP ports through the
    standard socket interface.

Package: ibacm
Architecture: linux-any
Depends: rdma-core (>= 15), ${misc:Depends}, ${shlibs:Depends}
Description: InfiniBand Communication Manager Assistant (ACM)
 The IB ACM implements and provides a framework for name, address, and
 route (path) resolution services over InfiniBand.
 It is intended to address connection setup scalability issues running
 MPI applications on large clusters.  The IB ACM provides information
 needed to establish a connection, but does not implement the CM protocol.
 A primary user of the ibacm service is the librdmacm library.

Package: ibverbs-providers
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: libefa1, libipathverbs1, libmana1, libmlx4-1, libmlx5-1, libmthca1
Replaces: libipathverbs1 (<< 15),
          libmlx4-1 (<< 15),
          libmlx5-1 (<< 15),
          libmthca1 (<< 15)
Breaks: libipathverbs1 (<< 15),
        libmlx4-1 (<< 15),
        libmlx5-1 (<< 15),
        libmthca1 (<< 15)
Description: User space provider drivers for libibverbs
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 An RDMA driver consists of a kernel portion and a user space portion.
 This package contains the user space verbs drivers:
 .
  - bnxt_re: Broadcom NetXtreme-E RoCE HCAs
  - cxgb4: Chelsio T4 iWARP HCAs
  - efa: Amazon Elastic Fabric Adapter
  - erdma: Alibaba Elastic RDMA (iWarp) Adapter
  - hfi1verbs: Intel Omni-Path HFI
  - hns: HiSilicon Hip06 SoC
  - ipathverbs: QLogic InfiniPath HCAs
  - irdma: Intel Ethernet Connection RDMA
  - mana: Microsoft Azure Network Adapter
  - mlx4: Mellanox ConnectX-3 InfiniBand HCAs
  - mlx5: Mellanox Connect-IB/X-4+ InfiniBand HCAs
  - mthca: Mellanox InfiniBand HCAs
  - ocrdma: Emulex OneConnect RDMA/RoCE device
  - qedr: QLogic QL4xxx RoCE HCAs
  - rxe: A software implementation of the RoCE protocol
  - siw: A software implementation of the iWarp protocol
  - vmw_pvrdma: VMware paravirtual RDMA device

Package: ibverbs-utils
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Examples for the libibverbs library
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 This package contains useful libibverbs1 example programs such as
 ibv_devinfo, which displays information about InfiniBand devices.

Package: libibverbs-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: ibverbs-providers (= ${binary:Version}),
         libibverbs1 (= ${binary:Version}),
         libnl-3-dev,
         libnl-route-3-dev,
         ${misc:Depends}
Description: Development files for the libibverbs library
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 This package is needed to compile programs against libibverbs1.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: libibverbs1
Architecture: linux-any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser, ${misc:Depends}, ${shlibs:Depends}
Recommends: ibverbs-providers
Breaks: ibverbs-providers (<< 34~)
Description: Library for direct userspace use of RDMA (InfiniBand/iWARP)
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 For this library to be useful, a device-specific plug-in module
 should also be installed.
 .
 This package contains the shared library.

Package: libibumad-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libibumad3 (= ${binary:Version}), ${misc:Depends}
Description: Development files for libibumad
 libibumad provides userspace Infiniband Management Datagram (uMAD)
 functions which sit on top of the uMAD modules in the kernel.
 These are used by InfiniBand diagnostic and management tools.
 .
 This package is needed to compile programs against libibumad.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: libibumad3
Architecture: linux-any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: InfiniBand Userspace Management Datagram (uMAD) library
 libibumad provides userspace Infiniband Management Datagram (uMAD)
 functions which sit on top of the uMAD modules in the kernel.
 These are used by InfiniBand diagnostic and management tools.
 .
 This package contains the shared library.

Package: librdmacm-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libibverbs-dev, librdmacm1t64 (= ${binary:Version}), ${misc:Depends}
Description: Development files for the librdmacm library
 librdmacm is a library that allows applications to set up reliable
 connected and unreliable datagram transfers when using RDMA adapters.
 It provides a transport-neutral interface in the sense that the same
 code can be used for both InfiniBand and iWARP adapters.  The
 interface is based on sockets, but adapted for queue pair (QP) based
 semantics: communication must use a specific RDMA device, and data
 transfers are message-based.
 .
 librdmacm only provides communication management (connection setup
 and tear-down) and works in conjunction with the verbs interface
 provided by libibverbs, which provides the interface used to actually
 transfer data.
 .
 This package is needed to compile programs against librdmacm.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: librdmacm1t64
Provides: ${t64:Provides}
Replaces: librdmacm1
Breaks: librdmacm1 (<< ${source:Version})
Architecture: linux-any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library for managing RDMA connections
 librdmacm is a library that allows applications to set up reliable
 connected and unreliable datagram transfers when using RDMA adapters.
 It provides a transport-neutral interface in the sense that the same
 code can be used for both InfiniBand and iWARP adapters.  The
 interface is based on sockets, but adapted for queue pair (QP) based
 semantics: communication must use a specific RDMA device, and data
 transfers are message-based.
 .
 librdmacm only provides communication management (connection setup
 and tear-down) and works in conjunction with the verbs interface
 provided by libibverbs, which provides the interface used to actually
 transfer data.
 .
 This package contains the shared library.

Package: rdmacm-utils
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Examples for the librdmacm library
 librdmacm is a library that allows applications to set up reliable
 connected and unreliable datagram transfers when using RDMA adapters.
 It provides a transport-neutral interface in the sense that the same
 code can be used for both InfiniBand and iWARP adapters.  The
 interface is based on sockets, but adapted for queue pair (QP) based
 semantics: communication must use a specific RDMA device, and data
 transfers are message-based.
 .
 librdmacm only provides communication management (connection setup
 and tear-down) and works in conjunction with the verbs interface
 provided by libibverbs, which provides the interface used to actually
 transfer data.
 .
 This package contains useful librdmacm example programs such as
 rping and udaddy.

Package: srptools
Architecture: linux-any
Depends: rdma-core (>= 15), udev, ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Tools for Infiniband attached storage (SRP)
 In conjunction with the kernel ib_srp driver, srptools allows you to
 discover and use Infiniband attached storage devices which use the
 SCSI RDMA Protocol (SRP).

Package: python3-pyverbs
Section: python
Architecture: linux-any
Depends: rdma-core (>= 21),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Python bindings for rdma-core
 Pyverbs provides a Python API over rdma-core, the Linux userspace C API for
 the remote direct memory access (RDMA) stack.
 .
 One goal is to provide easier access to RDMA: RDMA has a steep learning curve
 as is and the C interface requires the user to initialize multiple structs
 before having usable objects. Pyverbs attempts to remove much of this overhead
 and provide a smoother user experience.

Package: infiniband-diags
Architecture: linux-any
Depends: libibnetdisc5t64 (= ${binary:Version}),
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
